#include <stdio.h>
#include <math.h>   
#include "gba.h"
#include "birlib.h"

#include "gfx/background.map.c"
#include "gfx/background.pal.c"
#include "gfx/background.raw.c"

#include "gfx/pion_bleu.c"
#include "level.h"



#ifdef ACCELERO
#include "spitest.h"

struct sensor values;
int scale = -14;

void bir_InitAcc()
{
	values.Xoff = 2048;
  values.Yoff = 2048;
  values.Zoff = 2048;
  values.Xsens = 819;
  values.Ysens = 819;
  values.Zsens = 819;
  spiBusInit();
  enable();
}

void bir_AccTest()
{
	int oo = (int)(readX(values)*scale);
	int kk = (int)(readY(values)*scale);
	
	char truc[32];
	
	sprintf(truc,"%d - %d",oo,kk);
	bir_Print(truc,21,10);
}


#endif


/****************************************/
/*           Oleminant                  */
/****************************************/


#define OFFSET_X 0
#define OFFSET_Y 0

#define ROUGE  1
#define VERT   2
#define BLEU   3
#define NOIR   4
#define EXPL   5
#define BRIQUE 9

#define NIVEAUX 21

u8 grille[10][10] = {
	{ 0,0,0,0,0,0,0,0,0,0 },
	{ 0,0,0,0,0,0,0,0,0,0 },
	{ 0,0,0,0,0,0,0,0,0,0 },
	{ 0,0,0,0,0,0,0,0,0,0 },
	{ 0,0,0,0,0,0,0,0,0,0 },
	{ 0,0,0,0,0,0,0,0,0,0 },
	{ 0,0,0,0,0,0,0,0,0,0 },
	{ 0,0,0,0,0,0,0,0,0,0 },
	{ 0,0,0,0,0,0,0,0,0,0 },
	{ 0,0,0,0,0,0,0,0,0,0 }
};

u8 grillecount[10][10];



int rougeGfx;
int vertGfx;
int bleuGfx;
int noirGfx;
int briqueGfx;
int explGfx;

struct {
	u16 scroll;
	u8 move;
	u8 level;
	u8 movesmax;
} ole;

void bir_Sleep(int time)
{
	int i =0;
	while(i++ < time) {
		bir_ScrollBgXY(1,(ole.scroll>>2)&255,(ole.scroll>>2)&255);
		ole.scroll++;
		bir_WaitVBL();
	}
}

void ole_DisplayGrid()
{
	int i,j;
	for(i=0;i<10;i++) {
		for(j=0;j<10;j++) {
			if(grille[j][i] == 0)	bir_SetSpriteXY(20+i+j*10,240,160);
			if(grille[j][i] == ROUGE) bir_CreateSpriteFromGfx(20+i+j*10,rougeGfx, SIZE_16, OFFSET_X+i*16, OFFSET_Y+j*16);
			if(grille[j][i] == VERT) bir_CreateSpriteFromGfx(20+i+j*10,vertGfx, SIZE_16, OFFSET_X+i*16, OFFSET_Y+j*16);
			if(grille[j][i] == BLEU) bir_CreateSpriteFromGfx(20+i+j*10,bleuGfx, SIZE_16, OFFSET_X+i*16, OFFSET_Y+j*16);
			if(grille[j][i] == NOIR) bir_CreateSpriteFromGfx(20+i+j*10,noirGfx, SIZE_16, OFFSET_X+i*16, OFFSET_Y+j*16);
			if(grille[j][i] == BRIQUE) bir_CreateSpriteFromGfx(20+i+j*10,briqueGfx, SIZE_16, OFFSET_X+i*16, OFFSET_Y+j*16);
			if(grille[j][i] == EXPL) bir_CreateSpriteFromGfx(20+i+j*10,explGfx, SIZE_16, OFFSET_X+i*16, OFFSET_Y+j*16);
		}
	}
}

void ole_DisplayMoves()
{
	char truc[32];
	sprintf(truc,"%d/%d",ole.move,ole.movesmax);
	bir_Print(truc,21,5);
}

void ole_Level(u8 level, u8 niveau[10][10])
{
	int i,j;
	for(i=0;i<10;i++) {
		for(j=0;j<10;j++) {
			grille[i][j] = niveau[i][j];
		}
	}
	ole.level = level;
	ole.move = 0;
	ole.movesmax = 4;
	char truc[32];
	sprintf(truc,"%d",ole.level);
	bir_Print(truc,21,2);
}

void ole_Niveau(u8 level)
{
	
	switch(level)
	{
		case 1:
			ole_Level(1,niveau1);
		break;
		
		case 2:
			ole_Level(2,niveau2);
		break;
		
		case 3:
			ole_Level(3,niveau3);
		break;
		
		case 4:
			ole_Level(4,niveau4);
		break;
		
		case 5:
			ole_Level(5,niveau5);
		break;
		
		case 6:
			ole_Level(6,niveau6);
		break;
		
		case 7:
			ole_Level(7,niveau7);
		break;
		
		case 8:
			ole_Level(8,niveau8);
		break;
		
		case 9:
			ole_Level(9,niveau9);
		break;
		
		case 10:
			ole_Level(10,niveau10);
		break;
		
		case 11:
			ole_Level(11,niveau11);
		break;
		
		case 12:
			ole_Level(12,niveau12);
			ole.movesmax = 6;
		break;
		
		case 13:
			ole_Level(13,niveau13);
			ole.movesmax = 6;
		break;
		
		case 14:
			ole_Level(14,niveau14);
			ole.movesmax = 6;
		break;
		
		case 15:
			ole_Level(15,niveau15);
			ole.movesmax = 6;
		break;
		
		case 16:
			ole_Level(16,niveau16);
			ole.movesmax = 5;
		break;
		
		case 17:
			ole_Level(17,niveau17);
			ole.movesmax = 6;
		break;
		
		case 18:
			ole_Level(18,niveau18);
			ole.movesmax = 6;
		break;
		
		case 19:
			ole_Level(19,niveau19);
			ole.movesmax = 8;
		break;
		
		case 20:
			ole_Level(20,niveau20);
			ole.movesmax = 8;
		break;
		
		case 21:
			ole_Level(21,niveau21);
			ole.movesmax = 9;
		break;
		
	}
}


void ole_Init()
{
	/* GFX */
	DMACopyCH3((void*)background_Tiles, (void*)CharBaseBlock(1), 21312/2, DMA_32NOW);
	DMACopyCH3((void*)background_Map, (void*)ScreenBaseBlock(30), 1024/2, DMA_32NOW);
	
	bir_LoadSpritePal((u16*)pion_bleuPal);
	
	
	rougeGfx   = bir_CreateSpriteGfx((u16*)(pion_bleuTiles+16*0), SIZE_16);
	vertGfx    = bir_CreateSpriteGfx((u16*)(pion_bleuTiles+16*8), SIZE_16);
	bleuGfx    = bir_CreateSpriteGfx((u16*)(pion_bleuTiles+16*16),SIZE_16);
	noirGfx    = bir_CreateSpriteGfx((u16*)(pion_bleuTiles+16*24),SIZE_16);
	briqueGfx  = bir_CreateSpriteGfx((u16*)(pion_bleuTiles+16*32),SIZE_16);
	explGfx  = bir_CreateSpriteGfx((u16*)(pion_bleuTiles+16*40),SIZE_16);
 	
	
	
	ole_Level(1,niveau1);
	
	ole_DisplayGrid();
	ole_DisplayMoves();
}

void ole_ResetGrilleCount()
{
	int i,j;
	for(i=0;i<10;i++) {
		for(j=0;j<10;j++) {
			grillecount[i][j] = 0;
		}
	}
}

u8 ole_CountBlock(u8 x, u8 y)	{
	u8 count = 1; 
	u8 color = grille[y][x]; 
	grillecount[y][x] = 1; 
	if((x > 0)&&(grille[y][x-1] == color)&&(grillecount[y][x-1] == 0)) count += ole_CountBlock(x-1, y); 
	if((y > 0)&&(grille[y-1][x] == color)&&(grillecount[y-1][x] == 0)) count += ole_CountBlock(x, y-1);
	if((x < 9)&&(grille[y][x+1] == color)&&(grillecount[y][x+1] == 0)) count += ole_CountBlock(x+1, y); 
	if((y < 9)&&(grille[y+1][x] == color)&&(grillecount[y+1][x] == 0)) count += ole_CountBlock(x, y+1); 
	
	return count;
	
}

u8 ole_RemoveBlock(u8 x, u8 y, u8 expl){
	u8 count = 1; 
	u8 color = grille[y][x];
	grille[y][x] = expl;
	if((x > 0)&&(grille[y][x-1] == color)) count += ole_RemoveBlock(x-1, y,expl);
	if((y > 0)&&(grille[y-1][x] == color)) count += ole_RemoveBlock(x, y-1,expl);
	if((x < 9)&&(grille[y][x+1] == color)) count += ole_RemoveBlock(x+1, y,expl); 
	if((y < 9)&&(grille[y+1][x] == color)) count += ole_RemoveBlock(x, y+1,expl); 	

	return count;
}

int ole_CountGrille()
{
	int i,j;
	int cnt = 0;
	for(i=0;i<10;i++) {
		for(j=0;j<10;j++) {
			if(grille[i][j] > 0 && grille[i][j] < NOIR) cnt++;
		}
	}
	
	return cnt;
}


void ole_Check()
{
	int i,j;
	
	u8 destroy = 0;
	
	for(i=0;i<10;i++) {
		for(j=0;j<10;j++) {
			if(grille[j][i] > 0 && 	grille[j][i] < NOIR)
			{
				if(ole_CountBlock(i,j) > 1) {	
					ole_RemoveBlock(i,j,EXPL);
					destroy = 1;
				}
			}
		}
	}
	
	ole_DisplayGrid();
	
	if(destroy)	
	{
		bir_Sleep(10);
		for(i=0;i<10;i++) {
			for(j=0;j<10;j++) {
				if(grille[j][i] == EXPL)
				{
					ole_RemoveBlock(i,j,0);
				}
			}
		}
		ole_DisplayGrid();
	}
}


void ole_DecalBas()
{
	u8 x[16],y[16];
	u8 c = 0;
	u8 m = 0; //Compte le nombre de mouvement
	//On cherche les pions
	int i,j;
	for(i=0;i<10;i++) {
		for(j=0;j<10;j++) {
			if(grille[j][i] > 0 && grille[j][i] <= NOIR)
			{
					x[c] = i;
					y[c] = j;
					c++;
			}
		}
	}
	
	j = 0;
	
	for(i=0;i<c;i++) {
		j = y[i]+1;
		while(grille[j][x[i]] == 0)
		{
			//Animation de dcalge
			
			j++;
		}
		u8 temp_val = grille[y[i]][x[i]];
		grille[y[i]][x[i]] = 0;		
		grille[j-1][x[i]] = temp_val;
		if(y[i] != j-1) m++;
		
	}
	
	if(m > 0) ole.move++;
	
	ole_DisplayGrid();
	ole_DisplayMoves();
}

void ole_DecalHaut()
{
	u8 x[16],y[16];
	u8 c = 0;
	u8 m = 0; //Compte le nombre de mouvement
	//On cherche les pions
	int i,j;
	for(i=0;i<10;i++) {
		for(j=0;j<10;j++) {
			if(grille[j][i] > 0 && grille[j][i] <= NOIR)
			{
					x[c] = i;
					y[c] = j;
					c++;
			}
		}
	}
	
	j = 0;
	
	for(i=0;i<c;i++) {
		j = y[i]-1;
		while(grille[j][x[i]] == 0)
		{
			//Animation de dcalge
			
			j--;
		}
		u8 temp_val = grille[y[i]][x[i]];
		grille[y[i]][x[i]] = 0;		
		grille[j+1][x[i]] = temp_val;
		if(y[i] != j+1) m++;
		
	}
	
	if(m > 0) ole.move++;
	ole_DisplayGrid();
	ole_DisplayMoves();
}

void ole_DecalGauche()
{
	u8 x[16],y[16];
	u8 c = 0;
	u8 m = 0; //Compte le nombre de mouvement
	//On cherche les pions
	int i,j;
	for(i=0;i<10;i++) {
		for(j=0;j<10;j++) {
			if(grille[j][i] > 0 && grille[j][i] <= NOIR)
			{
					x[c] = i;
					y[c] = j;
					c++;
			}
		}
	}
	
	j = 0;
	
	for(i=0;i<c;i++) {
		j = x[i]-1;
		while(grille[y[i]][j] == 0)
		{
			//Animation de dcalge
			
			j--;
		}
		u8 temp_val = grille[y[i]][x[i]];
		grille[y[i]][x[i]] = 0;		
		grille[y[i]][j+1] = temp_val;
		if(x[i] != j+1) m++;
		
	}
	
	if(m > 0) ole.move++;
	ole_DisplayGrid();
	ole_DisplayMoves();
}

void ole_DecalDroite()
{
	u8 x[16],y[16];
	u8 c = 0;
	u8 m = 0; //Compte le nombre de mouvement
	//On cherche les pions
	int i,j;
	for(i=0;i<10;i++) {
		for(j=0;j<10;j++) {
			if(grille[j][i] > 0 && grille[j][i] <= NOIR)
			{
					x[c] = i;
					y[c] = j;
					c++;
			}
		}
	}
	
	j = 0;
	
	for(i=0;i<c;i++) {
		j = x[i]+1;
		while(grille[y[i]][j] == 0)
		{
			//Animation de dcalge
			
			j++;
		}
		u8 temp_val = grille[y[i]][x[i]];
		grille[y[i]][x[i]] = 0;		
		grille[y[i]][j-1] = temp_val;
		if(x[i] != j-1) m++;
		
	}
	
	if(m > 0) ole.move++;
	ole_DisplayGrid();
	ole_DisplayMoves();
}


void ole_AnimPerdu()
{
	BgPal[17] = RGB(31,0,0);
	BgPal[16] = RGB(31,31,31);
	bir_Sleep(6);
	BgPal[16] = RGB(31,0,0);
	BgPal[17] = RGB(31,31,31);
	bir_Sleep(6);
	BgPal[17] = RGB(31,0,0);
	BgPal[16] = RGB(31,31,31);
	bir_Sleep(6);
	BgPal[16] = RGB(31,0,0);
	BgPal[17] = RGB(31,31,31);
	bir_Sleep(6);
	BgPal[17] = RGB(31,0,0);
	BgPal[16] = RGB(31,31,31);
	bir_Sleep(6);
	BgPal[16] = RGB(31,0,0);
	BgPal[17] = RGB(31,31,31);
	bir_Sleep(6);
	BgPal[17] = RGB(31,0,0);
	BgPal[16] = RGB(31,31,31);
	bir_Sleep(6);
	BgPal[16] = RGB(31,31,31);
	BgPal[17] = RGB(29,29,29);
	bir_Sleep(6);
}

void ole_AnimGagne()
{
	BgPal[17] = RGB(0,0,31);
	BgPal[16] = RGB(31,31,31);
	bir_Sleep(6);
	BgPal[16] = RGB(0,0,31);
	BgPal[17] = RGB(31,31,31);
	bir_Sleep(6);
	BgPal[17] = RGB(0,0,31);
	BgPal[16] = RGB(31,31,31);
	bir_Sleep(6);
	BgPal[16] = RGB(0,0,31);
	BgPal[17] = RGB(31,31,31);
	bir_Sleep(6);
	BgPal[17] = RGB(0,0,31);
	BgPal[16] = RGB(31,31,31);
	bir_Sleep(6);
	BgPal[16] = RGB(0,0,31);
	BgPal[17] = RGB(31,31,31);
	bir_Sleep(6);
	BgPal[17] = RGB(0,0,31);
	BgPal[16] = RGB(31,31,31);
	bir_Sleep(6);
	BgPal[16] = RGB(31,31,31);
	BgPal[17] = RGB(29,29,29);
	bir_Sleep(6);
}


void ole_Game()
{
	bir_ScrollBgXY(1,(ole.scroll>>2)&255,(ole.scroll>>2)&255);
	ole.scroll++;

		
	u8 t_moves = 0;
	if(Pad.Newpress.Down)	{
		ole_DecalBas(); 
		t_moves = ole.move; 
		ole_DecalBas();
		if(ole.move != t_moves) ole.move--;
		ole_DisplayMoves();
		ole_ResetGrilleCount();
		ole_Check();
	}
	if(Pad.Newpress.Up)	{
		ole_DecalHaut(); 
		t_moves = ole.move;
		ole_DecalHaut();
		if(ole.move != t_moves) ole.move--;
		ole_DisplayMoves();
		ole_ResetGrilleCount();
		ole_Check();
	}
	if(Pad.Newpress.Left)	{ 	
		ole_DecalGauche(); 
		t_moves = ole.move;
		ole_DecalGauche(); 
		if(ole.move != t_moves) ole.move--;
		ole_DisplayMoves();
		ole_ResetGrilleCount();
		ole_Check();
	}
	if(Pad.Newpress.Right)	{ 
		ole_DecalDroite(); 
		t_moves = ole.move;	
		ole_DecalDroite();
		if(ole.move != t_moves) ole.move--;
		ole_DisplayMoves();
		ole_ResetGrilleCount();
		ole_Check();
	}
	
	if(ole_CountGrille() == 0)
	{
		ole_AnimGagne();
		if(ole.level < NIVEAUX) ole.level++;
		ole_Niveau(ole.level);
		ole_DisplayGrid();
		ole_DisplayMoves();
	}
	
	if(ole.move == ole.movesmax)
	{
		ole_AnimPerdu();
		ole_Niveau(ole.level);
		ole_DisplayGrid();
		ole_DisplayMoves();
	}
	
	if(Pad.Newpress.Start)	{
		ole_AnimGagne();
		ole_Niveau(ole.level);
		ole_DisplayGrid();
		ole_DisplayMoves();
	}
	
	
	if(Pad.Newpress.R)
	{
		ole_AnimGagne();
		if(ole.level < NIVEAUX) ole.level++;
		ole_Niveau(ole.level);
		ole_DisplayGrid();
		ole_DisplayMoves();
	}
	
	if(Pad.Newpress.L)
	{
		ole_AnimGagne();
		if(ole.level > 0) ole.level--;
		ole_Niveau(ole.level);
		ole_DisplayGrid();
		ole_DisplayMoves();
	}

}


int main(void)
{

	bir_Init(MODE_0);
	
	bir_LoadBgPal((u16*)background_Palette);
	bir_InitText();
	
	ole_Init();
	
	bir_Print("Level :",21,1);
	
	
	bir_Print("Moves :",21,4);

	
	while(1) 
	{
		ole_Game();
		
		bir_WaitVBL();
	}
	return 0;
}





















